(*
    Title: 	SCTermStream - Implementation
    LastEdit:	"Tue Feb 19 12:47:39 1985"
    Author: 	acm
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE SCTermStream;

FROM SYSTEM IMPORT ADDRESS;
FROM Streams IMPORT Stream;
FROM Terminal IMPORT NoTrans, DelProc;
IMPORT Terminal;

VAR S: Stream;
    Translate: BOOLEAN;

PROCEDURE Delete (s: Stream);
BEGIN
    IF s = S THEN
        S := NIL;
    END;
END Delete;

PROCEDURE CreateInOutput(): Stream;
BEGIN
    IF S = NIL THEN
        S := Terminal.CreateInOutput (NoTrans, Translate, Delete);
    END;
    RETURN S;
END CreateInOutput;

PROCEDURE TranslateCR (yes: BOOLEAN);
BEGIN
    Translate := yes;
    IF S # NIL THEN
        Terminal.TranslateCR (S, yes);
    END;
END TranslateCR;

PROCEDURE StreamErrorCode (s: Stream): INTEGER;
BEGIN
    RETURN Terminal.StreamErrorCode (s)
END StreamErrorCode;

BEGIN

    S := NIL;
    Translate := TRUE;

END SCTermStream.
