(*
    Title: 	Singly-linked list package - Implementation
    LastEdit:	"Tue May  3 16:44:15 1983"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory

*)

IMPLEMENTATION MODULE Slist;

FROM SYSTEM IMPORT ADDRESS, WORD, ADR;

PROCEDURE Add(VAR listhead: ADDRESS; newelement: ADDRESS);
BEGIN
    newelement^ := WORD(listhead);
    listhead := newelement;
END Add;

PROCEDURE AddE(VAR listhead: ADDRESS; newelement: ADDRESS);
VAR t, tf: ADDRESS;
BEGIN
    t := ADR(listhead);
    LOOP
        tf := ADDRESS(t^);
        IF tf = NIL THEN EXIT;
        ELSE
            t := tf;				(* onto next *)
        END;
    END;
    t^ := WORD(newelement);
    newelement^ := WORD(NIL);
END AddE;

PROCEDURE JoinE(VAR listhead: ADDRESS; newlist: ADDRESS);
VAR t, tf: ADDRESS;
BEGIN
    t := ADR(listhead);
    LOOP
        tf := ADDRESS(t^);
        IF tf = NIL THEN EXIT;
        ELSE
            t := tf;				(* onto next *)
        END;
    END;
    t^ := WORD(newlist);
END JoinE;

PROCEDURE Remove(VAR listhead: ADDRESS; element: ADDRESS);
VAR t, tf: ADDRESS;

BEGIN
    t := ADR(listhead);
    LOOP
	tf := ADDRESS(t^);
        IF tf = NIL THEN EXIT
        ELSIF tf = element THEN			(* match *)
            t^ := tf^;				(* remove it *)
            EXIT;
        ELSE
            t := tf;				(* onto next *)
        END;
    END;
END Remove;


END Slist .
