(*
    Title: 	UnixArgs - Implementation
    LastEdit:	"Fri Sep 14 10:39:01 1984"
    Author: 	Mick Jordan
		Acorn Research Centre
*)

IMPLEMENTATION MODULE UnixArgs;
FROM SYSTEM IMPORT BYTESPERWORD;
FROM SystemTypes IMPORT String;
FROM UnixMCI IMPORT ArgPtr, argvPtr;
FROM Exceptions IMPORT RAISE;

CONST 
      NoSuchArgument = "NoSuchArgument";

PROCEDURE GetArg(argnum: CARDINAL; VAR arg: ARRAY OF CHAR); 
VAR
    i: CARDINAL;
    charpos: String;
BEGIN
    IF argnum < argCount THEN
	charpos := argvPtr^[argnum+1];
        i := 0;
        WHILE charpos^[i] # 0C DO
	    arg[i] := charpos^[i];
            INC(i);
        END (* while *);
        IF i <= HIGH(arg) THEN
            arg[i] := 0C;
        END (* if *);
    ELSE
        RAISE(NoSuchArgument);
    END;
END GetArg;

BEGIN	(* UnixArgs initialization *)
    argCount := CARDINAL(argvPtr^[0])

END UnixArgs.

