IMPLEMENTATION MODULE BBC;

(*
    Title: 	Special functions for BBC terminal 
    LastEdit:	"Mon Aug 30 19:03:57 1982"
    Author: 	jd
		Cambridge University Computer Laboratory
*)

FROM SYSTEM IMPORT WORD;
FROM GKSTypes IMPORT WS, ESCAPECODE;
FROM GKSWork IMPORT Escape;


PROCEDURE GraphicsMode (bbc: WS; mode: GRAPHICSMODE);
    VAR m: INTEGER;
    VAR junk: ARRAY [0..0] OF WORD;
BEGIN
    CASE mode OF
        TwoColour:      m := 0;
    |   FourColour:     m := 1;
    |   EightColour:    m := 2
    END;
    Escape (bbc, SetMode, m, junk);
END GraphicsMode;

END BBC.
