(*
    Title: 	Initialise the RPC system
    LastEdit:	"Fri Dec 18 17:24:08 1987"
    Author: 	Derek McAuley,Oms1,4663,329629
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE RPCInit;


IMPORT
  NetMember, RPCCalls, RPCNaff, RPCNets, RPCReceive, 
  RPCRemote, RPCStates, RPCTable;


PROCEDURE Init(port:CARDINAL);
  BEGIN
    RPCNets.Init(port);
    RPCTable.Init();
    RPCNaff.Init();
    RPCReceive.Init();
    RPCRemote.Init();
    RPCStates.Init();
    RPCCalls.Init();
    NetMember.Init()
  END Init;

END RPCInit.
