MODULE refbug;
FROM Vector IMPORT IVEC, AXIS;
FROM Storage IMPORT ALLOCATE;
FROM SysStreams IMPORT sysOut;
FROM WriteF IMPORT WriteF1;

TYPE  CELL3 = POINTER TO
		RECORD
                    a,b,c,d : INTEGER
	        END;

    tt =  POINTER TO
	     ARRAY [1..4] OF
		POINTER TO
		    ARRAY [1..4] OF CELL3;

VAR Grid3 : tt;
    i,j : INTEGER;
    c : CELL3;
    p : IVEC;

PROCEDURE getit (pos : IVEC) : CELL3;
BEGIN
   RETURN Grid3^[pos[X]]^[pos[Y]]
END getit;

BEGIN
    NEW (Grid3);
    FOR i := 1 TO 4 DO
	NEW (Grid3^[i]);
	FOR j := 1 TO 4 DO
	    NEW (Grid3^[i]^[j]);
	    WITH Grid3^[i]^[j]^ DO
	        a := i * j + 1;
		b := i * j + 2;
		c := i * j + 3;
		d := i * j + 4;
	        END;
	    END;
	END;
    p[X] := 4;
    p[Y] := 3;
    c := getit (p);
    WriteF1 (sysOut, "%i\n", c^.a);
    WriteF1 (sysOut, "%i\n", c^.b);
    WriteF1 (sysOut, "%i\n", c^.c);
    WriteF1 (sysOut, "%i\n", c^.d);
END refbug.
