(*
    Title: 	Modula-2 Linker
    LastEdit:	"Tue Sep 18 13:30:06 1984"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory

    Driving module for Unix version.
*)


MODULE m2l;

FROM UnixArgs IMPORT 
    argCount, GetArg;

FROM Stop IMPORT Stop;
FROM UtilError IMPORT ReportError, SetPrompt;
FROM Linker IMPORT Link;
FROM Options IMPORT GetOptions;
FROM M2Files IMPORT HashExt;
FROM HashStrings IMPORT EnterChars;
IMPORT Strings;
IMPORT LModule;

VAR i: CARDINAL;
VAR argnum: CARDINAL;
VAR argname: ARRAY [0 .. 80] OF CHAR;
VAR status: CARDINAL;
VAR void, keysOk: BOOLEAN;
    root: LModule.MODULEPTR;
    rootmodulename: LModule.MODULENAME;

BEGIN
    status := 0;
    argnum := 1;
    SetPrompt("m2l");
    IF argCount < 2 THEN
        ReportError(TRUE, "Usage: m2l [options] module\n", 0, 0);
    ELSE
        LOOP
            GetArg(argnum, argname);
            IF argname[0] = '-' THEN GetOptions(argnum, argname);
            ELSE
                HashExt("key");
                void := EnterChars(LModule.Mtable, argname, rootmodulename);
                LModule.Add(rootmodulename, 0, root);
    	        keysOk := LModule.CheckKeys(root);
	        IF NOT keysOk THEN status := 1;
	        ELSE Link();
	        END;
                EXIT;
            END;
            INC(argnum);
            IF argnum = argCount THEN
              ReportError(TRUE, "name of module to be linked is missing",0,0);
            END;

        END; (* LOOP *)
    END; (* IF *)

    Stop(status);

END m2l .
