IMPLEMENTATION MODULE P1IOStr;

    FROM Storage IMPORT ALLOCATE, DEALLOCATE;
    FROM MCBase IMPORT Stringptr, Constval;
    FROM P1IOOut IMPORT Error;

    CONST stringmax = 100;

    TYPE Bufptr = POINTER TO Stringbuffer;
    TYPE Stringbuffer = ARRAY [1 .. stringmax] OF CHAR;

    VAR string : Bufptr;
        strcount : CARDINAL;
        ix : CARDINAL;

    PROCEDURE PutStrCh(ch: CHAR);
      (* put character into stringbuffer *)
    BEGIN
      INC(strcount);
      IF strcount > stringmax THEN
        Error(6);
        strcount := stringmax;
      END;
      string^[strcount] := ch;
    END PutStrCh;

    PROCEDURE InitString;
      (* initalisation of string area *)
    BEGIN
      strcount := 0;
      NEW(string);
    END InitString;

    PROCEDURE TermString(VAR length: CARDINAL; VAR val: Constval);
      VAR buffp : Bufptr;
          ix : CARDINAL;
          sval : Stringptr;
    BEGIN
      length := strcount;
      PutStrCh(0C);
      IF ODD(strcount) THEN PutStrCh(0C) END;
      ALLOCATE(buffp,strcount);
      (* array-structure is overlayed to allocated area *)
      FOR ix := 1 TO strcount DO buffp^[ix] := string^[ix] END;
      DISPOSE(string);
      (* string value entry *)
      NEW(sval);
      WITH sval^ DO
        loadoffset := 177777B; (* initialisation *)
        valentry := CARDINAL(buffp);
        slink := NIL; (* initialisation *)
      END;
      val.svalue := sval;
    END TermString; 

END P1IOStr .
