IMPLEMENTATION MODULE P3ExpType;

      FROM MCBase IMPORT
        Idptr, Stptr, Idclass, Structform,
        Stset, Varkind, Symbol,
        charptr, intptr, cardptr, intcarptr, addrptr;

      FROM MCImpl IMPORT Realsize;
      FROM P3Exp IMPORT Attribut, Attributmode, Expression, ExprSequence;
      FROM MCP3Ident IMPORT FAmong;
      FROM MCP3IO IMPORT PutGetSy, Error, ErrorLS, sy;
      FROM M2Pass3PV IMPORT scalars;

    PROCEDURE TypFunction(VAR at : Attribut); 
      CONST forms = Stset{sets,pointers} + scalars;
      VAR lat : Attribut;
    BEGIN
      PutGetSy; (* lparent *)
      IF sy = rparent THEN Error(137);
      ELSE
        Expression(lat);
        IF (at.atp <> NIL) AND (lat.atp <> NIL) THEN
          IF (at.atp^.size = lat.atp^.size) THEN
            IF (lat.mode = constm) AND
               FAmong(at.atp,forms) AND FAmong(lat.atp,forms)
            THEN
              at.mode := constm;
              at.aval := lat.aval;
            ELSIF (lat.atp^.form = arrays) AND (lat.atp^.dyn) THEN
              ErrorLS(120);
            END;
          ELSE
            at.atp := NIL;
            ErrorLS(120);
          END;
        END;
      END;
      IF sy = rparent THEN
        PutGetSy;
      ELSE
        ErrorLS(127); ExprSequence;
      END;
    END TypFunction;

      PROCEDURE OpenTest(VAR sp: Stptr);
      (* test on open structure and change to actual structure,
         including function types *)
      BEGIN
        IF (sp<>NIL) THEN
          IF sp^.form=opens THEN
              sp := sp^.openstruc;
          ELSIF (sp^.form=proctypes) AND (sp^.rkind=funcs) THEN
              OpenTest(sp^.funcp);
          END (* if *);
        END
      END OpenTest;

      PROCEDURE IsString(s: Stptr): BOOLEAN;
        VAR str: BOOLEAN; 
      BEGIN (* string structure ecpected *)
        str := FALSE;
        IF s<>NIL THEN
          WITH s^ DO
            IF (form=arrays) AND NOT dyn THEN 
              str := (elp=charptr) AND (ixp^.scalp=cardptr)
                                   AND (ixp^.min=0)
            END 
          END (* WITH s^ *)
        END;
        RETURN str;
      END IsString;

      PROCEDURE ProcedureCheck(sp1,sp2: Stptr): BOOLEAN;
        (* check type equality between two procedure structures *)
        VAR p1,p2 : Idptr;
            s1,s2 : Stptr;

        PROCEDURE DynArr(sp: Stptr): BOOLEAN; 
        BEGIN
          RETURN (sp <> NIL) AND (sp^.form = arrays) AND sp^.dyn
        END DynArr;

      BEGIN
        IF sp1^.rkind <> sp2^.rkind THEN RETURN FALSE END;
        p1 := sp1^.fstparam; p2 := sp2^.fstparam;
        LOOP
          IF p1 = p2 THEN EXIT END; (* paramlist checked *)
          IF (p1 = NIL) OR (p2 = NIL) OR (p1^.vkind <> p2^.vkind) THEN
            RETURN FALSE
          ELSE s1 := p1^.idtyp; s2 := p2^.idtyp;
            OpenTest(s1); OpenTest(s2);
            IF s1 <> s2 THEN
              IF DynArr(s1) AND DynArr(s2) THEN
                IF s1^.elp <> s2^.elp THEN RETURN FALSE END;
              ELSE RETURN FALSE
              END;
            END;
          END;
          p1 := p1^.vlink;
          p2 := p2^.vlink;
        END; (* LOOP *)
        (* exit loop only with equality *)
        IF sp1^.rkind = funcs THEN RETURN sp1^.funcp = sp2^.funcp 
        ELSE RETURN TRUE
        END;
      END ProcedureCheck; 

      PROCEDURE ExprComp(at1,at2 : Attribut) : BOOLEAN;
        (* compare two types to compatibility *)
        VAR t1p,t2p : Stptr;
      BEGIN
        t1p := at1.atp;
        t2p := at2.atp;
        IF (t1p=t2p) OR (t1p=NIL) OR (t2p=NIL) THEN RETURN TRUE END;
        IF t1p^.form = subranges THEN t1p := t1p^.scalp END;
        IF t2p^.form = subranges THEN t2p := t2p^.scalp END;
        IF (t1p=t2p) OR (t1p=NIL) OR (t2p=NIL) THEN RETURN TRUE END;
        IF (t2p = intcarptr) AND
           ((t1p = intptr) OR (t1p = cardptr)) THEN RETURN TRUE END;
        IF (t1p = intcarptr) AND
           ((t2p = intptr) OR (t2p = cardptr)) THEN RETURN TRUE END;
        IF ((at1.mode=varm) <> (at2.mode=varm)) THEN
          (* compatibility of different structrecs only between *)
          (* (constants/procedures) AND (variables/fields)      *)
          IF (t1p^.form=pointers) AND (t2p^.form=pointers) THEN
          (* NIL compatible to each pointer *)
            RETURN (t1p^.elemp=NIL) OR (t2p^.elemp=NIL);
          ELSIF (t1p^.form=proctypes) AND (t2p^.form=proctypes) THEN
            RETURN ProcedureCheck(t1p,t2p)
          ELSIF IsString(t1p) AND IsString(t2p) THEN (* string compatibility *)
            RETURN ((at1.mode=varm) <> (t1p^.ixp^.max<t2p^.ixp^.max)) OR
                   (t1p^.ixp^.max = t2p^.ixp^.max) OR
                   (t1p^.size = 0) OR (t2p^.size = 0);
          END;
        END;
        RETURN FALSE;
      END ExprComp;

      PROCEDURE AssignComp(at1,at2: Attribut): BOOLEAN;
        (* assignment compatibility *)
        CONST incar = Stset{ints,cards};
      BEGIN
        RETURN ExprComp(at1,at2) OR
               FAmong(at1.atp,incar) AND FAmong(at2.atp,incar)
      END AssignComp;

      PROCEDURE AddressComp(at1,at2: Attribut): BOOLEAN;
        (* compatibility to type ADDRESS *)
        VAR sp : Stptr;
      BEGIN
        IF at1.atp = addrptr THEN sp := at2.atp
        ELSIF at2.atp = addrptr THEN sp := at1.atp
        ELSE sp := NIL
        END;
        RETURN FAmong(sp,Stset{pointers})
      END AddressComp;

      PROCEDURE WordComp(sp: Stptr): BOOLEAN;
        (* compatibility to formal WORD parameter *)
      VAR clist: Stset;
      BEGIN
        clist := Stset{arrays,records};
	IF Realsize=1 THEN INCL(clist, reals); END;
        RETURN NOT FAmong(sp,clist);
      END WordComp;

END P3ExpType .
