IMPLEMENTATION MODULE P4Loop;

FROM MCP4CodeSys IMPORT
    PC, Emit, Emit2, MarkLong, UpdateLong; 
FROM MCBase IMPORT 
    Symbol;
FROM MCP4Global IMPORT 
    GetSymbol, spPosition;
FROM MCMnemonics IMPORT
    JP, JPB, DECS;
FROM P4Stat IMPORT StatSeq1;

    VAR 
      currendLoopPC: INTEGER;
      loopSPpos: INTEGER;

    PROCEDURE LoopStatement;   
      VAR lPC, outerLoopPC: INTEGER;
          outsideSPpos: INTEGER;
    BEGIN
      outerLoopPC  := currendLoopPC; currendLoopPC := 0;
      outsideSPpos := loopSPpos; loopSPpos := spPosition;
      lPC := PC;
      StatSeq1(endsy); GetSymbol; 
      lPC := PC-lPC+1;
      IF lPC>255 THEN Emit(JP); Emit2(-lPC)
      ELSE Emit(JPB); Emit(lPC);
      END;
      UpdateLong(currendLoopPC); currendLoopPC := outerLoopPC;
      loopSPpos := outsideSPpos
    END LoopStatement;  
    

    PROCEDURE ExitStatement;   
      VAR i: INTEGER;
    BEGIN  
      FOR i := loopSPpos+1 TO spPosition DO 
        Emit(DECS)
      END;
      Emit(JP); MarkLong(currendLoopPC) (* must use long jump *)
    END ExitStatement;  
    

  BEGIN
    currendLoopPC := 0 (*should never be used; 
                         but prevents error from exit without loop*)
END P4Loop .
