IMPLEMENTATION MODULE P4StFuOS;

  FROM MCImpl IMPORT BytesperWord;
  FROM MCBase IMPORT  
    Idptr, Stptr, noprio,
    Idclass, Structform, 
    Varkind, Stpures, Stfuncs, wordptr,
    Symbol, Stringptr, cardptr, intcarptr, intptr,
    addrptr, boolptr, charptr, realptr;

  FROM MCP4Global IMPORT 
    loadCount, arithmeticRangeCheck,
    GetSymbol, sy, cstPtr, nptr,
    cString, Error;

  FROM MCP4CodeSys IMPORT
   
    (*Codesys*)
         Emit, Emit2,
        
    (*SimpleCode*)
         EmitLI, UConstMul, UAddToTop, 

    (*TypeSystem*)
         ByteSize, IsArrayType;
    
  FROM MCP4AttributSys IMPORT
    ArithmeticType, Attribut, AtMode,
    HasAlreadyCode, Arithmetic,
    RangeCheck, SizeType,
    Load, LoadAddr, Store,
    LoadDynHigh;

  FROM MCP4ExpressionSy IMPORT
    Expression, Designator, ExpressionAndLoad;

  FROM MCMnemonics IMPORT
    LSA,
    GB1, GB, CX, CI, CF, FFCT,
    STORE, STOT, LODFW, LODFD, COPT, DECS, STOFV,
    TRA, TRAP,
    ADD, UADD, SUB,  USUB, SYS,
    SHR, SHL,  ANDD, ORR, ABSS, BIT, COM,
    FABS, CHKZ;

       PROCEDURE PutCCALLString(string: Stringptr; Size: CARDINAL);
       (* output name of C procedure as bytes after SYS instruction *)
       TYPE StringTemplatePtr = POINTER TO ARRAY [0..120] OF CHAR;(*pass 1 !*)
       VAR l, c: CARDINAL;
           stp: StringTemplatePtr;
       BEGIN
        (* Length of string *)
        stp := StringTemplatePtr(string^.valentry);
        FOR c := 0 TO Size-1 DO
	  Emit(stp^[c]);
        END;
       END PutCCALLString;

PROCEDURE StandFuncOS(VAR fat: Attribut; fCalling: Stfuncs);
VAR 
    lat1: Attribut;
    lsize, UNIXcode, argc, CCALLStringSize, lloadCount: CARDINAL;
    CCALLStringptr: Stringptr;

BEGIN
    CASE fCalling OF
          regf: (* REGISTER *)
	    lloadCount := loadCount;
            Expression(fat);
            fat.typtr := intcarptr;
	    fat.mode := loadedMod;
            Emit(SYS); Emit(2); Emit(1); Emit(fat.value);
	    loadCount := lloadCount+1;

        | ccaf: (* CCALL *)
	(*  Assert(sy = stringcon) *)
	    lloadCount := loadCount;
            argc := 0;
(* Simulate the important things that a call to 'Expression' would do *)
            WITH fat DO
	        typtr := cstPtr;
		mode := loadedMod;
	    END;
(* make a copy of cString, and its length.			      *)
            CCALLStringptr := cString;
	    CCALLStringSize := cstPtr^.ixp^.max+1;
	    GetSymbol;
            LOOP
                IF sy <> comma THEN EXIT END;
                GetSymbol;
                Expression(lat1); Load(lat1);
                INC(argc);
            END;
	    Emit(SYS); Emit(CCALLStringSize+2); Emit(2); Emit(argc);
	    PutCCALLString(CCALLStringptr, CCALLStringSize);
	    fat.typtr := wordptr;
	    loadCount := lloadCount+1;

        | uxcf: (* UNIXCALL *)
	    lloadCount := loadCount;
            Expression(fat); 
            UNIXcode := fat.value;
            argc := 0;
            LOOP
                IF sy <> comma THEN EXIT END;
                GetSymbol;
                Expression(lat1); Load(lat1);
                INC(argc);
            END;
	    Emit(SYS); Emit(3); Emit(0); Emit(UNIXcode); Emit(argc);
	    fat.mode := loadedMod;
	    fat.typtr := intptr;
	    loadCount := lloadCount+1;
    END;
END StandFuncOS;

END P4StFuOS .


