IMPLEMENTATION MODULE P4Stat;

FROM MCBase IMPORT Symbol;
FROM MCP4AttributSys IMPORT Attribut;
FROM MCP4Global IMPORT GetSymbol, sy, loadCount;
FROM MCP4CallSys IMPORT
    ProcFuncCall;
FROM MCP4ExpressionSy IMPORT Designator;

  FROM P4Case IMPORT CaseStatement;
  FROM P4If IMPORT IfStatement;
  FROM P4For IMPORT ForStatement;
  FROM P4Misc IMPORT RepeatStatement, WhileStatement, ReturnStatement,
      Assignment,  WithStatement;
  FROM P4Loop IMPORT LoopStatement, ExitStatement;

  PROCEDURE Statement;   
    VAR lat: Attribut;
  BEGIN (* Statement *)  
    IF sy = becomes THEN GetSymbol; Assignment  
    ELSIF sy = call THEN GetSymbol;   
      Designator(lat); GetSymbol(*lparent*); ProcFuncCall(lat)  
    ELSIF sy = ifsy THEN GetSymbol; IfStatement  
    ELSIF sy = casesy THEN GetSymbol; CaseStatement  
    ELSIF sy = loopsy THEN GetSymbol; LoopStatement  
    ELSIF sy = whilesy THEN GetSymbol; WhileStatement  
    ELSIF sy = repeatsy THEN GetSymbol; RepeatStatement  
    ELSIF sy = withsy THEN GetSymbol; WithStatement  
    ELSIF sy = exitsy THEN GetSymbol; ExitStatement;  
    ELSIF sy = returnsy THEN GetSymbol; ReturnStatement  
    ELSIF sy = forsy THEN GetSymbol; ForStatement  
    (* ELSE empty statement without GetSymbol*)  
    END;
    (*loadCount is 0 but may be erronous because of code procedures*)
    loadCount := 0
  END Statement;  

  PROCEDURE StatSeq1(s: Symbol);    
  BEGIN  
    REPEAT 
      Statement   
    UNTIL sy = s  
  END StatSeq1;  

  PROCEDURE StatSeq3(s1, s2, s3: Symbol);   
  BEGIN  
    REPEAT
      Statement 
    UNTIL (sy = s1) OR (sy = s2) OR (sy = s3)   
  END StatSeq3;  

END P4Stat.
