(*
  Title:	m2make
  $Header: m2make.mod,v 1.3 88/02/26 16:15:05 dm Exp $
  		Copyright (C) 1984 by Acorn Research Centre
*)

MODULE m2make;

FROM UtilError IMPORT SetPrompt;
IMPORT GenGraph;
IMPORT GenDirs;
IMPORT GenMakeFile;
IMPORT ArgHandler;
IMPORT AppendUser;

BEGIN
  SetPrompt("m2make");
  ArgHandler.ParseArguments;
  AppendUser.Try();
  GenDirs.Build;
  GenGraph.Build;
  GenMakeFile.Build;

END m2make.

(*
$Log:	m2make.mod,v $
Revision 1.3  88/02/26  16:15:05  dm
Changes for -a flag

Revision 1.2  85/01/04  10:40:24  mjj
Parse arguments before building directory list, to allow
M2PATH to be altered by -E option.

Revision 1.1  84/11/30  16:19:49  mjj
Initial revision

*)

