(*
    Title: 	File handling for M2 linker - Implementation
    LastEdit:	"Thu Sep 13 13:30:57 1984"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory
*)

(*  Bstreams version 					      *)

IMPLEMENTATION MODULE FileH;

FROM Streams IMPORT 
    Stream, ErrorCode, Delete;
    
IMPORT M2Files;
IMPORT Strings;
FROM SystemTypes IMPORT String;

FROM UtilError IMPORT ReportError;
FROM WriteF IMPORT S;

PROCEDURE OpenKeyFile(name: String; VAR fname: ARRAY OF CHAR): Stream;
VAR s: Stream;
    nameAsChars: ARRAY [0..255] OF CHAR;
BEGIN
    Strings.CopySC(name, nameAsChars);
    s := M2Files.CreateInput(nameAsChars, "key");
    IF s^.status # Success THEN
        ReportError(TRUE, "unable to open key file for %S", S(name), 0);
    ELSE
        Strings.CopyCC(M2Files.Filename, fname);
	RETURN s;
    END;
END OpenKeyFile;


END FileH  .
