(*
    Title: 	Random - Implementation
    LastEdit:	"Mon Jan 11 13:28:30 1988"
    Author: 	jd
		Cambridge University Computer Laboratory

    Pseudo-Random Numbers from a Fibonacci series
*)
IMPLEMENTATION MODULE Random;

IMPORT
  SYSTEM, UnixLibCall;

(*
VAR fibonacci: ARRAY BOOLEAN OF CARDINAL;
VAR b: BOOLEAN;
*)

PROCEDURE Seed (c: CARDINAL);
BEGIN
    SYSTEM.CALLEXTPROC(UnixLibCall.srandom, c)
(*  fibonacci [b] := c;
    b := NOT b; *)
END Seed;

PROCEDURE RandomCard(): CARDINAL;
BEGIN
    RETURN CARDINAL(SYSTEM.CALLEXTFUNC(UnixLibCall.random));
(*  fibonacci [b] := fibonacci [TRUE] + fibonacci [FALSE];
    b := NOT b;
    RETURN fibonacci [b]; *)
END RandomCard;

PROCEDURE Uniform (lwb, upb: CARDINAL): CARDINAL;
BEGIN
    IF upb <= lwb THEN
        RETURN lwb
    ELSE RETURN (RandomCard () MOD (upb - lwb + 1)) + lwb;
    END;
END Uniform;

PROCEDURE ZeroTo (l: CARDINAL): CARDINAL;
BEGIN
    RETURN RandomCard() MOD (l+1)
END ZeroTo;

PROCEDURE OneTo (l: CARDINAL): CARDINAL;
BEGIN
    RETURN 1 + (RandomCard() MOD l)
END OneTo;

(*
BEGIN
    b := FALSE;
    fibonacci [FALSE] := 214376922;
    fibonacci [TRUE] := 436098648;
*)
END Random.
