(*
    Title: 	TermStream - Implementation
    LastEdit:	"Tue Feb 19 12:42:35 1985"
    Author: 	acm
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE TermStream;

FROM Streams IMPORT Stream;
IMPORT Terminal;
FROM Terminal IMPORT CreateStdInOutput;

PROCEDURE StreamErrorCode (s: Stream): INTEGER;
BEGIN
    RETURN Terminal.StreamErrorCode (s);
END StreamErrorCode;

PROCEDURE CreateInOutput(): Stream;
BEGIN
    RETURN CreateStdInOutput();
END CreateInOutput;

PROCEDURE CreateOutputForErrors(): Stream;
BEGIN
    RETURN Terminal.CreateOutputForErrors();
END CreateOutputForErrors;

END TermStream.
