(*
    Title: 	UNIX Synchronous IO - dummy for blocking threads
    LastEdit:	"Mon Jan 25 16:24:13 1988"
    Author: 	Derek McAuley,Oms1,4652
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE UnixSelect;

IMPORT 
  Exceptions, SYSTEM, UnixCall;

PROCEDURE WaitForRead(fd:INTEGER);
  BEGIN 
  END WaitForRead;


PROCEDURE WaitForWrite(fd:INTEGER);
  BEGIN 
  END WaitForWrite;

  
PROCEDURE LastThread();
  BEGIN 
    Exceptions.RAISE("Wrong version of Select module")
  END LastThread;


PROCEDURE Poll();
  BEGIN 
  END Poll;


PROCEDURE Select(
      nfds:INTEGER; 
  VAR readFs, writeFs, exceptFs:ARRAY OF BITSET;
  VAR timeout:TimeVal
 ):INTEGER;
  VAR
    n:INTEGER;
  BEGIN
    n :=
      INTEGER(
        SYSTEM.CALLEXTFUNC(UnixCall.select, 
                           nfds,
                           SYSTEM.ADR(readFs), 
                           SYSTEM.ADR(writeFs), 
                           SYSTEM.ADR(exceptFs), 
                           SYSTEM.ADR(timeout)));
    RETURN n
  END Select;


END UnixSelect.
