(*
    Title: 	UnixSignals - Implementation
    LastEdit:	"Mon Sep 29 11:34:20 1986"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory

    68000 / Unix version (and it's messy)
*)


IMPLEMENTATION MODULE UnixSignals;
FROM SYSTEM IMPORT ADDRESS, WORD, UNIXCALL, CALLEXTFUNC, ADR;
FROM UnixCalls IMPORT signal;
FROM Storage IMPORT ALLOCATE;

CONST templatelength = 8;
      procoffset = 5;
TYPE
    ENTRY = POINTER TO ENTRYDATA;
    ENTRYDATA = RECORD
                    link : ENTRY;  
		    m2h : WORD;
                    cproc: POINTER TO ARRAY [0..templatelength] OF WORD;
                END;
                
VAR head : ENTRY;
    sigtemplate : POINTER TO ARRAY [0..templatelength-1] OF WORD;
    
PROCEDURE Signal(signo: CARDINAL; handler: WORD): WORD;
    VAR h : WORD;
        e : POINTER TO ENTRY;
        found : BOOLEAN;
    BEGIN
        h := handler;
        IF (CARDINAL (handler) # SIGIGN) AND
           (CARDINAL (handler) # SIGDFL) THEN
            e := ADR (head);
            found := FALSE;
            WHILE NOT found DO
                IF e^ = NIL THEN
                    CreateM2Handler (e^, handler);
                    found := TRUE;
                    h := WORD (e^^.cproc);
                ELSE IF CARDINAL (handler) = CARDINAL (e^^.m2h) THEN
                     found := TRUE;
                     h := WORD (e^^.cproc);
                     END;
                END;
                e := ADR (e^^.link);
            END;
        END;
        RETURN WORD( UNIXCALL(signal, signo, h));
    END Signal;

PROCEDURE CreateM2Handler (VAR entry : ENTRY; m2hand : WORD);
VAR i : CARDINAL;
BEGIN
   NEW (entry);
   entry^.link := NIL;
   entry^.m2h := m2hand;
   NEW (entry^.cproc);
   FOR i := 0 TO templatelength - 1
       DO entry^.cproc^[i] := sigtemplate^[i]
   END;
   entry^.cproc^[procoffset] := m2hand;
END CreateM2Handler;

BEGIN
   NEW (sigtemplate);
   sigtemplate^[0] := WORD (04e7148e7H);
   sigtemplate^[1] := WORD (0ffff2a7cH);
   sigtemplate^[2] := WORD (0);
   sigtemplate^[3] := WORD (0267cffffH);
   sigtemplate^[4] := WORD (0ffff207cH);
   sigtemplate^[5] := WORD (0);
   sigtemplate^[6] := WORD (04e904cdfH);
   sigtemplate^[7] := WORD (0ffff4e75H);
   head := NIL;
END UnixSignals.
