(*
    Title: 	UtilError - Implementation
    LastEdit:	"Sun Sep 23 16:26:11 1984"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory

    Unix version
*)

IMPLEMENTATION MODULE UtilError;
FROM SYSTEM IMPORT WORD;
FROM SysStreams IMPORT sysErr;
FROM WriteF IMPORT WriteF0, WriteF1, WriteF2, H;
FROM Stop IMPORT Stop;
FROM UnixArgs IMPORT GetArg;
IMPORT Strings;

VAR Dprompt: ARRAY [0 .. 79] OF CHAR;

PROCEDURE ReportPError(prompt: ARRAY OF CHAR; fatal: BOOLEAN; 
                      string: ARRAY OF CHAR; arg1, arg2: WORD);
    BEGIN
        WriteF1(sysErr, "%S: ", H(prompt));
        WriteF2(sysErr, string, arg1, arg2);
        WriteF0(sysErr, "\n");
        IF fatal THEN
            Stop(1);
        END (* if *);
    END ReportPError;

PROCEDURE ReportError(fatal: BOOLEAN; 
                      string: ARRAY OF CHAR; arg1, arg2: WORD);
    BEGIN
        ReportPError(Dprompt, fatal, string, arg1, arg2);
    END ReportError;

PROCEDURE SetPrompt(prompt: ARRAY OF CHAR);
    BEGIN
        Strings.CopyCC(prompt, Dprompt);
    END SetPrompt;

BEGIN
    GetArg(0, Dprompt);
END UtilError.
