IMPLEMENTATION MODULE WSAbilities;

(*
    Title: 	Available colours from GKS
    LastEdit:	"Wed Aug 19 11:59:13 1987" by Tony Mann
    Author: 	acm
		Qudos Limited
*)


(* This modules makes available the colours that your GKS back can draw.
   It is not part of GKS, and is an addition to it purely for convenience.

   It is up to the GKSDev module to set the variable palette. Older versions
   of GKSDev may not do this in which case palette will be the empty set.
*)

FROM Palette IMPORT COLOUR, PALETTE;


PROCEDURE Colours (): CARDINAL;
VAR colours: CARDINAL;
    c: COLOUR;
BEGIN
    colours := 0;
    FOR c := Black TO LightGrey DO
        IF c IN palette THEN INC (colours) END;
    END;
    RETURN colours;
END Colours;


BEGIN

    palette := PALETTE {};
    linesPerPage := 25.0;
    sizedText := FALSE;
    rotatedText := FALSE;

END WSAbilities.
