(*
    Title: 	The Member program
    LastEdit:	"Thu Feb 25 17:48:21 1988"
    Author: 	Derek McAuley,Oms1,4652
		Cambridge University Computer Laboratory
*)

MODULE Member;


IMPORT
  Binder, NetMember, RPCInit, Sec, SSSecStub, SSNetMember, Timers;


PROCEDURE Main();
  VAR
    mrc:RPC.MemberRC;
  BEGIN
    RPCInit.Init(Binder.Port);

    SSNetMember.Offer();

    SSSecStub.Offer(Strings.CopyCS(Sec.StubName), RPC.SameMachine);

    secName := Strings.CopyCS(Sec.Name);
    mrc := NetMember.Offer(secName, RPC.SameMachine, ??);
    CSSecServ.Find(secName, RPC.SameMachine);

    LOOP Timers.WaitSecs(6000, Timers.FromNow) END;
  END Main;


BEGIN
  Main()
END Member.
