MODULE withbug;
CONST MaxMapSize = 100;
TYPE
  SlotType = [1..5];
  UnivAddr = RECORD Lo: CARDINAL; END;
  Map = RECORD OldAddressTo: UnivAddr; END;
  Lookup = ARRAY [0..MaxMapSize] OF Map;
  Config = RECORD LookupTable: Lookup; END;
VAR
  SlotsConfig : ARRAY SlotType OF Config;
  CurrSlotNo : CARDINAL;
  i : [0..MaxMapSize];

PROCEDURE UnivEqual (one:UnivAddr) : BOOLEAN;
BEGIN
  RETURN FALSE;
END UnivEqual;

BEGIN
  CurrSlotNo := 1;
  i := 0;
  WITH SlotsConfig [CurrSlotNo] DO
    WHILE NOT (UnivEqual (LookupTable[i].OldAddressTo)) DO
      IF i > 3 THEN HALT END;
      INC (i);
    END;
  END;
END withbug.
