IMPLEMENTATION MODULE M2Pass2PV;

FROM MCBase IMPORT 
    Stptr, Stset, Idset, Idptr, Idclass, Structform,
    Symbol, mainmodp;
FROM MCP2Ident IMPORT SearchId, ExportSearch;
FROM MCP2IO IMPORT GetSy, sy, ErrorLS, spix;

  PROCEDURE FAmong(sp: Stptr; forms: Stset): BOOLEAN;
  BEGIN
    IF sp = NIL THEN RETURN FALSE END;
    WITH sp^ DO
      RETURN (form IN forms) OR
             (form = subranges) AND FAmong(scalp,forms);
    END;
  END FAmong;

  PROCEDURE QualIdent(klset: Idset; errnum: CARDINAL; VAR ip: Idptr);
  BEGIN (* sy = ident *)
    SearchId(ip); 
    LOOP
      GetSy;
      IF sy <> period THEN EXIT END;
      IF (ip <> NIL) AND (ip^.klass = mods) THEN
        GetSy;
        ExportSearch(ip^.expp,ip); (* new value for ip *)
      ELSE ErrorLS(105); GetSy;
      END;
    END;
    IF ip = NIL THEN
      ErrorLS(errnum);
    ELSIF NOT (ip^.klass IN klset) THEN
      ErrorLS(103); (* identifier not of expected klass *)
      ip := NIL;
    END;
  END QualIdent;

  PROCEDURE InitId(ip: Idptr; cl: Idclass);
    (* initialisation of identifier record *)
  BEGIN
    WITH ip^ DO
      name := spix; (* from MCP2IO *)
      globmodp := mainmodp;
      idtyp := NIL; (* = nxtidp *)
      klass := cl; link := NIL;
    END;
  END InitId;

END M2Pass2PV .

