IMPLEMENTATION MODULE P4CallParam;

  FROM MCImpl IMPORT BytesperWord, MaxCard;
  FROM MCBase IMPORT  
    Idptr, Stptr, noprio,
    Idclass, Structform, 
    Varkind, Stpures, Stfuncs, wordptr,
    mainmodp, Symbol;

  FROM MCP4Global IMPORT 
    level, loadCount,
    GetSymbol, sy,  
    Error;

  FROM MCP4CodeSys IMPORT
   
    (*Codesys*)
         Emit, Emit2, LinkageMark,  
        
    (*SimpleCode*)
         EmitLI, EmitCL, UConstMul, UAddToTop, 

    (*TypeSystem*)
         ByteSize;

  FROM P4CodeBlk IMPORT
         CodeBody;

  FROM MCP4AttributSys IMPORT
    ArithmeticType, AtMode, Attribut, ModeSet,
    HasAlreadyCode, Arithmetic,
    RangeCheck,
    Load, LoadAddr,
    LoadDynHigh, PreAssign;

  FROM MCP4ExpressionSy IMPORT
    Expression;

  FROM MCMnemonics IMPORT
    LSA,
    GB1, GB, CX, CI, CF, FFCT,
    STORE, STOT, LODFW, LODFD, COPT, DECS, STOFV,
    TRA, TRAP,
    ADD, UADD, SUB,  USUB, SYS,
    SHR, SHL,  ANDD, ORR, ABSS, BIT, COM,
    FABS, CHKZ;

      PROCEDURE DynParam(VAR fat: Attribut; IsBlock: BOOLEAN);   
        VAR s: CARDINAL;
      BEGIN  
        WITH fat DO  
          WITH typtr^ DO
(*            Assert((form=arrays) OR IsBlock);   *)
            IF (form=arrays) AND dyn THEN 
              LoadAddr(fat);  
              LoadDynHigh(fat);  
              IF IsBlock THEN
                IF ByteSize(elp) THEN
(*                Emit(LSA); Emit(1); (* Add ONE!!! *)		      *)
                  EmitLI(1); Emit(UADD);
                  EmitLI(BytesperWord DIV 2); Emit(SHR) 
                ELSE s := elp^.size;
                  UConstMul(s); 
                  IF s>1 THEN
                    IF s<=256 THEN Emit(LSA); Emit(s-1)
                    ELSE EmitLI(s-1); Emit(UADD) END
                  END
                END
              END
            ELSE  
              IF IsBlock THEN
                IF mode IN ModeSet{globalMod, localMod, addrLoadedMod,
                                   externalMod, indexMod, doubleIndexMod, 
                                   absolutMod, stringTemplateMod} THEN 
                  LoadAddr(fat); EmitLI(size-1)  
                ELSE Error(201) END  
              ELSE
                LoadAddr(fat);  
                WITH ixp^ DO  
                  IF max>=min THEN EmitLI(max-min) 
                  ELSE EmitLI(MaxCard-min+max+1) END;  
                END  
              END
            END  
          END
        END  
      END DynParam;  

    PROCEDURE LoadParam(fsp: Stptr);          
    VAR lat: Attribut; LNP: Idptr;  
  
    BEGIN (* LoadParam *)  
(*      Assert((fsp<>NIL) AND (fsp^.form=proctypes));    *)
      LNP := fsp^.fstparam;   
      WHILE LNP<>NIL DO  
        WITH LNP^ DO  
          Expression(lat);  
          IF (vkind=copyparam) OR (vkind=varparam) THEN  
            IF (vkind=varparam) AND (lat.mode=byteIndexMod) THEN
              Error(206)  
            ELSIF lat.mode=loadedMod THEN 
              Error(201); (*occurs through type converters*)
            ELSIF (idtyp^.form=arrays) AND idtyp^.dyn THEN
              DynParam(lat, (idtyp^.elp=wordptr))  
            ELSE
              LoadAddr(lat)  
            END
          ELSE  
            RangeCheck(idtyp, lat);
            Load(lat)  
          END;  
          LNP := vlink;  
          IF LNP<>NIL THEN 
            GetSymbol (*comma*)
          END  
        END  
      END;  
      GetSymbol (*rparent*)  
    END LoadParam;  

END P4CallParam .
