IMPLEMENTATION MODULE P4For;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM MCBase IMPORT
    Symbol, Stptr, intptr, cardptr;
FROM MCP4AttributSys IMPORT
    Attribut, RangeCheck, Load, AtMode, TestBaseType, LoadAddr;
FROM MCP4Global IMPORT
    GetSymbol, sy, Error, val,
    controlRangeCheck, loadCount, spPosition,
    arithmeticRangeCheck;
FROM MCP4CodeSys IMPORT
    Emit, EmitLI, Emit2, Emit2GivePC, Insert, 
    Insert2, Fixup2, PC, MoveCode;
FROM MCMnemonics IMPORT JPFC, JPF, JP, JPC, FOR1, FOR2, CHKS;
FROM MCP4ExpressionSy IMPORT
    Expression, Designator;
FROM M2Pass4PV IMPORT Skip;
FROM P4Stat IMPORT  StatSeq1, StatSeq3;
 
  PROCEDURE ForStatement;   
    VAR 
      cntat, lat: Attribut;  
      step: INTEGER;  
      loopPC, exPC: INTEGER;

    PROCEDURE LoadAndTest(VAR fat: Attribut);
      (* special runtime test; control variable handled
         as integer by hardware *)
      VAR bt: Stptr;
    BEGIN bt := TestBaseType(fat.typtr);
      IF fat.mode=constantMod THEN
        IF (bt=cardptr)
          (* means cardinal > maxint! usually int or intcar or scalar *) 
        THEN Error(222) END;
        RangeCheck(cntat.typtr, fat);
        Load(fat) 
      ELSE
        Load(fat);
        IF (TestBaseType(cntat.typtr)=cardptr) AND (TestBaseType(fat.typtr)=cardptr) THEN
          (*sorry i'm to lazy *)
          IF arithmeticRangeCheck THEN Emit(CHKS) END; 
          RangeCheck(cntat.typtr, fat)
        ELSE                                   
          RangeCheck(cntat.typtr, fat)
        END
      END
    END LoadAndTest;

  BEGIN  
    Designator(cntat); LoadAddr(cntat);  
    GetSymbol; (*comma*)  
    Expression(lat); LoadAndTest(lat);  
    GetSymbol; (*tosy*)  
    Expression(lat); LoadAndTest(lat);  
    DEC(loadCount, 3);
    IF sy=bysy THEN GetSymbol; GetSymbol;  
      step := val  
    ELSE step := 1 END;  
    Emit(FOR1);
    IF (step=0) (* OR (step>127) OR (step<-128) *) THEN Error(202) END;
    IF step>0 THEN Emit(0) ELSE Emit(1) END;
    Emit2GivePC(exPC);
    loopPC := PC;
    INC(spPosition, 2);
    StatSeq1(endsy); GetSymbol;  
    DEC(spPosition, 2);
    Emit(FOR2);
    Emit2(step);
    Emit2(loopPC-PC); Fixup2(exPC)
  END ForStatement;  
    

END P4For .
